#include "bits/stdc++.h"

using namespace std;

int main() {
  // Wczytujemy dane wejsciowe.
  int H, W;
  cin >> H >> W;

  int N;
  cin >> N;

  vector<int> A(N);
  for (int i = 0; i < N; i++) {
    cin >> A[i];
  }

  // Odpowiedz poczatkowo bedzie rowna -1,
  // jezeli nie znajdziemy zadnego telewizora
  // ktory zmiesci sie na scianie, odpowiedzia
  // pozostanie -1.
  int odpowiedz = -1;

  for (int i = 0; i < N; i++) {
    // Ustalmy x jako jednostke bazowa telewizora, tak aby
    // 9x bylo jego wysokoscia, a 16x jego szerokoscia.
    // Wtedy z twierdzenia Pitagorasa:
    // (9x)^2 + (16x)^2 = A^2
    // (9 * 9 + 16 * 16) x ^ 2 = A^2
    // x = sqrt(A^2 / (9 * 9 + 16 * 16))
    double x = sqrt((double)A[i] * A[i] / (9 * 9 + 16 * 16));

    // Obliczamy zatem wysokosc i szerokosc, najpierw w calach.
    double wysokosc_telewizora_w_calach = x * 9;
    double szerokosc_telewizora_w_calach = x * 16;

    // Pozniej przekonwertujemy cale do centymetrow.
    double wysokosc_telewizora_w_cm = wysokosc_telewizora_w_calach * 2.54;
    double szerokosc_telewizora_w_cm = szerokosc_telewizora_w_calach * 2.54;

    // I sprawdzamy czy telewizor zmiesci sie na scianie.
    if (wysokosc_telewizora_w_cm <= H and szerokosc_telewizora_w_cm <= W) {
      // Jeżeli tak, to aktualizujemy odpowiedź. Szukamy
      // największego telewizora, więc bierzemy maksimum
      // z dotychczasowej odpowiedzi i aktualnego telewizora.
      odpowiedz = max(odpowiedz, A[i]);
    }
  }

  // Finalnie wypisujemy odpowiedź.
  if (odpowiedz == -1)
    // Jeżeli nie znaleźliśmy żadnego telewizora i odpowiedź jest dalej równa
    // -1, to wypisujemy NIE.
    cout << "NIE\n";
  else
    // W przeciwnym wypadku wypisujemy znalezioną odpowiedź
    // - największy telewizor, który zmieści się na ścianie.
    cout << odpowiedz << "\n";
}